// Dial_ParSet.cpp : implementation file
//

#include "stdafx.h"
#include "RectCol.h"
#include "RCDoc.h"
#include "MainFrm.h"
#include "RCView.h"

#include "Dial_ParSet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDial_ParSet dialog


CDial_ParSet::CDial_ParSet(CRCDoc *pDOC,CWnd* pParent /*=NULL*/)
	: CDialog(CDial_ParSet::IDD, pParent)
{pDoc=pDOC;
 double CoeffVozvr;
 if(pDoc->bFlegmaCoeffFlegNumber)
 {if(pDoc->COEF_VOZVRATA<1.0) CoeffVozvr=pDoc->COEF_VOZVRATA/(1.0-pDoc->COEF_VOZVRATA);
  else CoeffVozvr=100000.0;
 }
 else CoeffVozvr=pDoc->COEF_VOZVRATA;
 	//{{AFX_DATA_INIT(CDial_ParSet)
	m_dEdit_CoeffVozvr = CoeffVozvr;
	m_dEdit_OxlFlegma = pDoc->OXL_FLEGMA;
	m_iEdit_NumIteration = pDoc->NUM_ITERATION_SHOW;
	m_Chk_TypeFlegmaCoeff = pDoc->bFlegmaCoeffFlegNumber;
	m_dEdit_ParMass = pDoc->InpParState.m;
	m_dEdit_SpirtConc = pDoc->SpirtConcentrInBraga;
	m_dEdit_ParTemp = pDoc->InpParState.t;
	m_dEdit_ExtCoolingPower = pDoc->ExtCoolingPower;
	m_dEdit_StartTempTar = pDoc->StartTempTar;
	m_Edit_NumTar = pDoc->NumTar;
	m_Chk_AutoParTemp = pDoc->bAutoParTemperature;
	//}}AFX_DATA_INIT
}


void CDial_ParSet::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDial_ParSet)
	DDX_Text(pDX, IDC_EDIT_COEFF_VOZVR, m_dEdit_CoeffVozvr);
	DDX_Text(pDX, IDC_EDIT_OXL_FLEGMA, m_dEdit_OxlFlegma);
	DDX_Text(pDX, IDC_EDIT_NUM_ITERATION, m_iEdit_NumIteration);
	DDX_Check(pDX, IDC_CHECK_TYPE_FLEGMA_COEFF, m_Chk_TypeFlegmaCoeff);
	DDX_Text(pDX, IDC_EDIT_PAR_MASS, m_dEdit_ParMass);
	DDX_Text(pDX, IDC_EDIT_SPIRT_CONC, m_dEdit_SpirtConc);
	DDX_Text(pDX, IDC_EDIT_PAR_TEMP, m_dEdit_ParTemp);
	DDX_Text(pDX, IDC_EDIT_EXT_COOLING_POWER, m_dEdit_ExtCoolingPower);
	DDX_Text(pDX, IDC_EDIT_START_TEMP_TAR, m_dEdit_StartTempTar);
	DDX_Text(pDX, IDC_EDIT_NUM_TAR, m_Edit_NumTar);
	DDX_Check(pDX, IDC_CHECK_AUTO_COUNT, m_Chk_AutoParTemp);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDial_ParSet, CDialog)
	//{{AFX_MSG_MAP(CDial_ParSet)
	ON_BN_CLICKED(IDC_BUTT_COUNT_TEMP, OnButtCountTemp)
	ON_BN_CLICKED(IDB_SET_DEFAULT, OnSetDefault)
	ON_EN_CHANGE(IDC_EDIT_SPIRT_CONC, OnChangeEditSpirtConc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDial_ParSet message handlers
void CDial_ParSet::UpdateDocData()
{if(!UpdateData(true)) return;
 if(m_Chk_TypeFlegmaCoeff)
	pDoc->COEF_VOZVRATA=m_dEdit_CoeffVozvr/(1.0+m_dEdit_CoeffVozvr);
 else pDoc->COEF_VOZVRATA=m_dEdit_CoeffVozvr;
 pDoc->OXL_FLEGMA=m_dEdit_OxlFlegma;
 pDoc->NUM_ITERATION_SHOW=m_iEdit_NumIteration;
 pDoc->bFlegmaCoeffFlegNumber=m_Chk_TypeFlegmaCoeff;
 pDoc->InpParState.m=m_dEdit_ParMass;
 pDoc->SpirtConcentrInBraga=m_dEdit_SpirtConc;
 pDoc->InpParState.n=pDoc->GetRastvParConc(m_dEdit_SpirtConc)*m_dEdit_SpirtConc;
 pDoc->bAutoParTemperature=m_Chk_AutoParTemp;
 if(m_Chk_AutoParTemp) pDoc->InpParState.t=pDoc->GetRastvTKip(m_dEdit_SpirtConc);
 else pDoc->InpParState.t=m_dEdit_ParTemp;
 pDoc->ExtCoolingPower=m_dEdit_ExtCoolingPower;
 pDoc->StartTempTar=m_dEdit_StartTempTar;
 if(pDoc->NumTar!=m_Edit_NumTar)
	 {pDoc->NumTar=m_Edit_NumTar;
	  pDoc->StartInitParams();
	  CMainFrame *pMF=(CMainFrame *)AfxGetMainWnd();
	  ((CRCView *)pMF->pView[0])->ReinitAll();
	  pDoc->bEnbNextModel=false;
	  CMenu *pMN=pMF->GetMenu();
	  pMN->EnableMenuItem(IDM_NEXT_ITERATION,MF_DISABLED|MF_GRAYED);
	  pMF->DrawMenuBar();
	 };
}

void CDial_ParSet::OnOK() 
{UpdateDocData();
 CDialog::OnOK();
}

void CDial_ParSet::OnButtCountTemp() 
{if(!UpdateData(true)) return;
 m_dEdit_ParTemp=pDoc->GetRastvTKip(m_dEdit_SpirtConc);
 UpdateData(false);
}

void CDial_ParSet::OnSetDefault() 
{if(!UpdateData(true)) return;
 UpdateDocData();
 pDoc->SaveRegistryParams();
}

void CDial_ParSet::OnChangeEditSpirtConc() 
{//if(!UpdateData(true))
//	{return;
//	};
 //if(m_Chk_AutoParTemp) m_dEdit_ParTemp=pDoc->GetRastvTKip(m_dEdit_SpirtConc);
 //UpdateData(false);
}
