// FView.cpp : implementation file
//
#include <math.h>

#include "stdafx.h"
#include "rectcol.h"
#include "RCDoc.h"
#include "MainFrm.h"

#include "FView.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFView

IMPLEMENT_DYNCREATE(CFView, CFormView)

CFView::CFView()
	: CFormView(CFView::IDD)
{
	//{{AFX_DATA_INIT(CFView)
	m_Edit_BakFlegmaCon = _T("");
	m_Edit_BakFlegmaMass = _T("");
	m_Edit_BakFlegmaTemp = _T("");
	m_Edit_BakParCon = _T("");
	m_Edit_BakParMass = _T("");
	m_Edit_BakParTemp = _T("");
	m_Edit_DeflegPower = _T("");
	m_Edit_InputPower = _T("");
	m_Edit_OutCon = _T("");
	m_Edit_OutMass = _T("");
	m_Edit_OutMass1000 = _T("");
	//}}AFX_DATA_INIT
	bFirstTest=true;
	bStopTest=false;
}

CFView::~CFView()
{
}

void CFView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFView)
	DDX_Text(pDX, IDC_EDIT_BAK_FLEG_CON, m_Edit_BakFlegmaCon);
	DDX_Text(pDX, IDC_EDIT_BAK_FLEG_MASS, m_Edit_BakFlegmaMass);
	DDX_Text(pDX, IDC_EDIT_BAK_FLEG_TEMP, m_Edit_BakFlegmaTemp);
	DDX_Text(pDX, IDC_EDIT_BAK_PAR_CON, m_Edit_BakParCon);
	DDX_Text(pDX, IDC_EDIT_BAK_PAR_MASS, m_Edit_BakParMass);
	DDX_Text(pDX, IDC_EDIT_BAK_PAR_TEMP, m_Edit_BakParTemp);
	DDX_Text(pDX, IDC_EDIT_DEFLEG_POWER, m_Edit_DeflegPower);
	DDX_Text(pDX, IDC_EDIT_INP_POWER, m_Edit_InputPower);
	DDX_Text(pDX, IDC_EDIT_OUT_CON, m_Edit_OutCon);
	DDX_Text(pDX, IDC_EDIT_OUT_MASS, m_Edit_OutMass);
	DDX_Text(pDX, IDC_EDIT_OUT_MASS1, m_Edit_OutMass1000);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFView, CFormView)
	//{{AFX_MSG_MAP(CFView)
	ON_BN_CLICKED(IDC_BUT_TEST, OnButTest)
	ON_BN_CLICKED(IDC_BUT_TEST_NEXT, OnButTestNext)
	ON_BN_CLICKED(IDC_BUT_TEST_STOP, OnButTestStop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFView diagnostics

#ifdef _DEBUG
void CFView::AssertValid() const
{
	CFormView::AssertValid();
}

void CFView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CFView message handlers

void CFView::OnDraw(CDC* pDC) 
{CString cs;
 double f,f1;
 CRCDoc *pDoc=(CRCDoc *)GetDocument();
 cs.Format("%.3f",pDoc->pISArr[0].FS.n);
 m_Edit_BakFlegmaCon = cs;
 cs.Format("%.3f",pDoc->pISArr[0].FS.m);
 m_Edit_BakFlegmaMass = cs;
 cs.Format("%.3f",pDoc->pISArr[0].FS.t);
 m_Edit_BakFlegmaTemp = cs;
 cs.Format("%.3f",pDoc->pISArr[0].PS.n);
 m_Edit_BakParCon = cs;
 cs.Format("%.3f",pDoc->pISArr[0].PS.m);
 m_Edit_BakParMass = cs;
 cs.Format("%.3f",pDoc->pISArr[0].PS.t);
 m_Edit_BakParTemp = cs;
 cs.Format("%.3f",pDoc->ColDeflegPower);
 m_Edit_DeflegPower = cs;
 cs.Format("%.3f",pDoc->ColInpPower);
 m_Edit_InputPower = cs;
 f=pDoc->pISArr[pDoc->NumTar].PS.n*100;
 f1=-0.0284+1.26996*f-0.00179*f*f-9.0712E-6*f*f*f;
 cs.Format("%.3f ( %.3f)",
	 pDoc->pISArr[pDoc->NumTar].PS.n*100.0,
	 f1);
 m_Edit_OutCon = cs;
 cs.Format("%.3f (%.1f /)",
	 pDoc->pISArr[pDoc->NumTar].PS.m*(1.0-pDoc->COEF_VOZVRATA),
	 pDoc->pISArr[pDoc->NumTar].PS.m*(1.0-pDoc->COEF_VOZVRATA)*3600.0
	 );
 m_Edit_OutMass = cs;
  cs.Format("%.3f (/)",
	 pDoc->pISArr[pDoc->NumTar].PS.m*(1.0-pDoc->COEF_VOZVRATA)*3600.0/pDoc->ColInpPower*1000.0
	 );
 m_Edit_OutMass1000 = cs;


 UpdateData(false);
}


void CFView::OnButTest() 
{int i=0;
 TarState *pTS;
 CRCDoc *pDoc=(CRCDoc *)GetDocument();
 CMainFrame *pMF=(CMainFrame *)AfxGetApp()->m_pMainWnd;
 pTS=new TarState[pDoc->NumTar];
 bStopTest=false;
 if(bFirstTest) {pMF->InitModel(); bFirstTest=false;};

 pMF->IterateModel();
 memcpy(pTS,pDoc->pTS,sizeof(TarState)*pDoc->NumTar);
 //pTS=new TarState[NumTar];
 pMF->IterateModel();
 while(!CompareTarTemp(pTS,pDoc->pTS,pDoc->NumTar,0.001) && (!bStopTest))
 {memcpy(pTS,pDoc->pTS,sizeof(TarState)*pDoc->NumTar);
  pMF->IterateModel();
 };
 if(bStopTest) AfxMessageBox("Command Stop");
 delete pTS;
 pMF->SetMessageText("End Work");
/* MSG msg;
	 while( PeekMessage(  &msg, NULL, 0, 0, PM_REMOVE ) )
		{TranslateMessage( &msg );
		 DispatchMessage( &msg );
		};
*/
}

BOOL CFView::CompareTarTemp(TarState *pT0, TarState *pT1, int NumTar, double MaxDif)
{int i;
 for(i=0;i<NumTar;i++)
 {double d;
  d=fabs(pT0[i].t-pT1[i].t);
  if(d>MaxDif) return false;
 };
 TRACE("CompareTarTemp:Goog\n");
 return true;
}

void CFView::OnButTestNext() 
{
	OnButTest(); 
	
}

void CFView::OnButTestStop() 
{
 bStopTest=true;
	
}
