// MainFrm.cpp : implementation of the CMainFrame class
//
#include <math.h>

#include "stdafx.h"
#include "RectCol.h"
#include "RCDoc.h"
#include "Dial_ParSet.h"
#include "RCView.h"
#include "FView.h"


#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(IDM_SET_PARAMS, OnSetParams)
	ON_COMMAND(IDM_START_MODEL, OnStartModel)
	ON_COMMAND(IDM_NEXT_ITERATION, OnNextIteration)
	ON_COMMAND(IDM_FILE_SAVE_AS, OnFileSaveAs)
	ON_COMMAND(IDM_SOUND, OnSound)
	ON_UPDATE_COMMAND_UI(IDM_SOUND, OnUpdateSound)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	bSound=true;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
//  -  	
/*	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
*/
	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
//	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
//	EnableDocking(CBRS_ALIGN_ANY);
//	DockControlBar(&m_wndToolBar);
	
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{// create a static splitter with 2 row, 1 columns
	if (!m_wndSplitter.CreateStatic(this, 2, 1))
		{TRACE0("Failed to CreateStaticSplitter\n");
		 return FALSE;
		};	


	// add the first splitter pane - an List View in column 0
	if (!m_wndSplitter.CreateView(0, 0,
		RUNTIME_CLASS(CRCView), CSize(300, 295), pContext))
		{TRACE0("Failed to create first pane\n");
		 return FALSE;
		};

	if (!m_wndSplitter.CreateView(1, 0,
		RUNTIME_CLASS(CFView), CSize(300, 150), pContext))
		{TRACE0("Failed to create second pane\n");
		 return FALSE;
		};
	// activate the List view
	SetActiveView((CScrollView *)m_wndSplitter.GetPane(0,0));

	int npos=0;
	CRCDoc *pDoc=(CRCDoc *)GetActiveDocument();
	POSITION pos = pDoc->GetFirstViewPosition();
	while (pos != NULL)
		{pView[npos] = pDoc->GetNextView(pos);
		 ASSERT_VALID(pView[npos]);
		 npos++;
		};
	return true;	
	//return CFrameWnd::OnCreateClient(lpcs, pContext);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers
void CMainFrame::OnSetParams() 
{CRCDoc *pDoc=(CRCDoc *)GetActiveDocument();
 CDial_ParSet dial(pDoc);
   if(dial.DoModal()==IDOK)
   {pDoc->pISArr[0].PS=pDoc->InpParState;
   };
}

void CMainFrame::OnStartModel() 
{CRCDoc *pDoc=(CRCDoc *)GetActiveDocument();
 if(pDoc==NULL) return;
 InitModel();
 IterateModel();
 pDoc->bEnbNextModel=true;
 CMenu *pMN=GetMenu();
 pMN->EnableMenuItem(IDM_NEXT_ITERATION,MF_ENABLED);
 DrawMenuBar();
}

void CMainFrame::OnNextIteration() 
{IterateModel();
}

void CMainFrame::InitModel()
{CString cs,cs1;
 CRCDoc *pDoc=(CRCDoc *)GetActiveDocument();
 if(pDoc==NULL) return;
 // 
 pDoc->StartInitParams();
 pDoc->CommonNumIterations=0;
}

void CMainFrame::IterateModel()
{int i,k=0,m;
 double EPS0,EPV0,EFS0,EFV0,EPS1,EPV1,E0,E1,nSpP,nVP,nSpF,nVF;
 CString cs;
 CRCDoc *pDoc=(CRCDoc *)GetActiveDocument();
 if(pDoc==NULL) return;
 SetMessageText("Working... ");
 BeginWaitCursor();
 m=pDoc->NUM_ITERATION_SHOW/100;
 while(k++<pDoc->NUM_ITERATION_SHOW)
	{for(i=0;i<pDoc->NumTar;i++)
		{if(i!=pDoc->NumTar-1) pDoc->CalcTar(i,&pDoc->pISArr[i],&pDoc->pTS[i],&pDoc->pISArr[i+1]);
		 else
		 {pDoc->pISArr[i+1].FS.m=pDoc->pISArr[i+1].PS.m*pDoc->COEF_VOZVRATA;// 
		  pDoc->pISArr[i+1].FS.n=pDoc->pISArr[i+1].PS.n;
		  pDoc->pISArr[i+1].FS.t=pDoc->pISArr[i+1].PS.t-pDoc->OXL_FLEGMA;// 
		  pDoc->CalcTar(i,&pDoc->pISArr[i],&pDoc->pTS[i],&pDoc->pISArr[i+1]);
		 };
		};
	 m--;
	 if(m<=0)
		 {m=pDoc->NUM_ITERATION_SHOW/100;
		  cs.Format("Working... Iteration %d",k);
		  SetMessageText(cs);
		 };
	 MSG msg;
	 while( PeekMessage(  &msg, NULL, 0, 0, PM_REMOVE ) )
		{TranslateMessage( &msg );
		 DispatchMessage( &msg );
		};
	};
   // 
   //   
   //     
   nSpP=pDoc->pISArr[0].PS.m*pDoc->pISArr[0].PS.n;
   EPS0=pDoc->pISArr[0].PS.t*nSpP*pDoc->GetSpirtTeploemc(pDoc->pISArr[0].PS.t);
   nVP=pDoc->pISArr[0].PS.m*(1.0-pDoc->pISArr[0].PS.n);
   EPV0=pDoc->pISArr[0].PS.t*nVP*pDoc->GetVodaTeploemc(pDoc->pISArr[0].PS.t);
   //       
   nSpF=pDoc->pISArr[0].FS.m*pDoc->pISArr[0].FS.n;
   EFS0=nSpF*pDoc->pISArr[0].FS.t*pDoc->GetSpirtTeploemc(pDoc->pISArr[0].FS.t);
   nVF=pDoc->pISArr[0].FS.m*(1.0-pDoc->pISArr[0].FS.n);
   EFV0=nVF*pDoc->pISArr[0].FS.t*pDoc->GetVodaTeploemc(pDoc->pISArr[0].FS.t);
   //,   
   EPS1=pDoc->pISArr[pDoc->NumTar].PS.m*pDoc->pISArr[pDoc->NumTar].PS.n*pDoc->GetSpirtTepIsp(pDoc->pISArr[pDoc->NumTar].PS.t);
   EPV1=pDoc->pISArr[pDoc->NumTar].PS.m*(1.0-pDoc->pISArr[pDoc->NumTar].PS.n)*pDoc->GetVodaTepIsp(pDoc->pISArr[pDoc->NumTar].PS.t);
   //    
   //   
   E0=EPS0+EPV0-EFS0-EFV0
	   +nSpP*pDoc->GetSpirtTepIsp(pDoc->pISArr[0].FS.t)
	   +nVP*pDoc->GetVodaTepIsp(pDoc->pISArr[0].FS.t);
   pDoc->ColInpPower=E0;
   //  
   E1=EPS1+EPV1;
   pDoc->ColDeflegPower=E1;
  
  ((CRCView *)pView[0])->MyInvalidate(true);
  ((CFView *)pView[1])->Invalidate();
  EndWaitCursor();
  SetMessageText("Ready");
  if(bSound) sndPlaySound("SystemHand",SND_ASYNC);
  return;
}

void CMainFrame::OnFileSaveAs() 
{int i;
 //double f,f1;
 char s[256];
 sprintf(s,"Untitled");
 FILE *fo;
 CString cs,cs1;
 CRCDoc *pDoc=(CRCDoc *)GetActiveDocument();

 //f=pDoc->pISArr[pDoc->NumTar].PS.n*100;
 //f1=-0.0284+1.26996*f-0.00179*f*f-9.0712E-6*f*f*f;
 
 CFileDialog FD(false,"txt");
 FD.m_ofn.lpstrFilter="Text files *.txt\0*.txt\0All files *.*\0*.*\0";
 FD.m_ofn.lpstrFile=s;
 if(FD.DoModal()!=IDOK) return;
 if((fo=fopen(FD.m_ofn.lpstrFile,"wt"))==NULL)
	 {cs.Format("Can't open file %s",FD.m_ofn.lpstrFile);
	  AfxMessageBox(cs);
	  return;
	 };
 fprintf(fo," \n"
	 " =%d\n"
	 "    =%.3f\n"
	 "      =%.3f\n"
	 "   =%.3f\n"
	 "      =%.3f\n"
	 " =%.3f\n"
	 " =%.3f \n"
	 "  =%.3f \n"
	 "    =%.3f\n"
	 "       =%.3f\n"
	 "    =%.3f\n"
	 "   =%.3f\n"
	 ",    =%.3f\n"
	 "    =%.3f (=%.3f)\n"
	 "    =%.3f (/=%.3f)\n"
	 "      1000 =%.3f (/)\n",
	 pDoc->NumTar,pDoc->SpirtConcentrInBraga,pDoc->InpParState.n,
	 pDoc->InpParState.t,pDoc->InpParState.m,
	 1.0>pDoc->COEF_VOZVRATA?pDoc->COEF_VOZVRATA/(1.0-pDoc->COEF_VOZVRATA):100000.0,
	 pDoc->OXL_FLEGMA,pDoc->ExtCoolingPower,
	 pDoc->pISArr[0].FS.m,pDoc->pISArr[0].FS.n,pDoc->pISArr[0].FS.t,
	 pDoc->ColInpPower,pDoc->ColDeflegPower,
	 pDoc->pISArr[pDoc->NumTar].PS.n*100.0,
	 pDoc->ConvMassConToVolCon(pDoc->pISArr[pDoc->NumTar].PS.n)*100.0,
	 pDoc->pISArr[pDoc->NumTar].PS.m*(1.0-pDoc->COEF_VOZVRATA),
	 pDoc->pISArr[pDoc->NumTar].PS.m*(1.0-pDoc->COEF_VOZVRATA)*3600.0,
	 pDoc->pISArr[pDoc->NumTar].PS.m*(1.0-pDoc->COEF_VOZVRATA)*3600.0/pDoc->ColInpPower*1000.0
	 );	 
 fprintf(fo,"NTar\tTmasF\tTconF\tTtempF\tParMas\tParCon\tParTemp\tFlegMas\tFlegCon\tFlegTemp\n");
 for(i=0;i<pDoc->NumTar;i++)
	 {fprintf(fo,"%d\t%.3f\t%.3f\t%.3f\t%.3f\t%.3f\t%.3f\t%.3f\t%.3f\t%.3f\n",
			i,pDoc->pTS[i].m,pDoc->pTS[i].n,pDoc->pTS[i].t,
			pDoc->pISArr[i+1].PS.m,pDoc->pISArr[i+1].PS.n,pDoc->pISArr[i+1].PS.t,
			pDoc->pISArr[i+1].FS.m,pDoc->pISArr[i+1].FS.n,pDoc->pISArr[i+1].FS.t);
	 };
 fclose(fo);
}


void CMainFrame::OnSound() 
{
	bSound = !bSound;
	
}

void CMainFrame::OnUpdateSound(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(bSound);
	
}
