// RCDoc.cpp : implementation of the CRCDoc class
//
#include <math.h>

#include "stdafx.h"
#include "RectCol.h"

#include "RCDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

char *psColNames[10]={" ","","","",
					"-","-","-",
					"-","-","-"};
/////////////////////////////////////////////////////////////////////////////
// CRCDoc

IMPLEMENT_DYNCREATE(CRCDoc, CDocument)

BEGIN_MESSAGE_MAP(CRCDoc, CDocument)
	//{{AFX_MSG_MAP(CRCDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRCDoc construction/destruction

CRCDoc::CRCDoc()
{pTS=0;
 pISArr=0;
 bEnbNextModel=false;
 bAutoParTemperature=true;
}

CRCDoc::~CRCDoc()
{if(pTS!=0) delete pTS;
 if(pISArr!=0) delete pISArr;
}

BOOL CRCDoc::OnNewDocument()
{int i;
 CWinApp *pApp=AfxGetApp();
 if (!CDocument::OnNewDocument()) return FALSE;
 CString cs;

 if((i=pApp->GetProfileInt("Settings","NumTar",-1))==-1)
	{NumTar=10;
	 pApp->WriteProfileInt("Settings","NumTar",NumTar);
	}
 else NumTar=i;

 if((i=pApp->GetProfileInt("Settings","CoeffVozvrataType",-1))==-1)
	{bFlegmaCoeffFlegNumber=false;
	 pApp->WriteProfileInt("Settings","CoeffVozvrataType",bFlegmaCoeffFlegNumber);
	}
 else bFlegmaCoeffFlegNumber=i;

 if((i=pApp->GetProfileInt("Settings","bAutoParTemperature",-1))==-1)
	{bAutoParTemperature=true;
	 pApp->WriteProfileInt("Settings","bAutoParTemperature",bAutoParTemperature);
	}
 else bAutoParTemperature=i;
 

 if((cs=pApp->GetProfileString("Settings","CoeffVozvrata",""))=="")
	{COEF_VOZVRATA=1.0;
	 cs.Format("%f",COEF_VOZVRATA);
	 pApp->WriteProfileString("Settings","CoeffVozvrata",cs);
	}
 else COEF_VOZVRATA=atof((LPCTSTR)cs);

 if((cs=pApp->GetProfileString("Settings","FlegmaCooling",""))=="")
	{OXL_FLEGMA=1.0;
	 cs.Format("%f",OXL_FLEGMA);
	 pApp->WriteProfileString("Settings","FlegmaCooling",cs);
	}
 else OXL_FLEGMA=atof((LPCTSTR)cs);

 if((i=pApp->GetProfileInt("Settings","NumIterationShow",-1))==-1)
	{NUM_ITERATION_SHOW=1000;
	 pApp->WriteProfileInt("Settings","NumIterationShow",NUM_ITERATION_SHOW);
	}
 else NUM_ITERATION_SHOW=i;
 
 if((cs=pApp->GetProfileString("Settings","SpirtConcentrInBraga",""))=="")
	{SpirtConcentrInBraga=0.1;
	 cs.Format("%f",SpirtConcentrInBraga);
	 pApp->WriteProfileString("Settings","SpirtConcentrInBraga",cs);
	}
 else SpirtConcentrInBraga=atof((LPCTSTR)cs);

 if((cs=pApp->GetProfileString("Settings","InpParMass",""))=="")
	{InpParState.m=1.0;
	 cs.Format("%f",InpParState.m);
	 pApp->WriteProfileString("Settings","InpParMass",cs);
	}
 else InpParState.m=atof((LPCTSTR)cs);
 
 if((cs=pApp->GetProfileString("Settings","InpParConcentr",""))=="")
	{InpParState.n=0.52;
	 cs.Format("%f",InpParState.n);
	 pApp->WriteProfileString("Settings","InpParConcentr",cs);
	}
 else InpParState.n=atof((LPCTSTR)cs);
 
 if((cs=pApp->GetProfileString("Settings","InpParTemp",""))=="")
	{InpParState.t=92.5;
	 cs.Format("%f",InpParState.t);
	 pApp->WriteProfileString("Settings","InpParTemp",cs);
	}
 else InpParState.t=atof((LPCTSTR)cs);
 
 if((cs=pApp->GetProfileString("Settings","ExtCoolingPower",""))=="")
	{ExtCoolingPower=0.0;
	 cs.Format("%f",ExtCoolingPower);
	 pApp->WriteProfileString("Settings","ExtCoolingPower",cs);
	}
 else ExtCoolingPower=atof((LPCTSTR)cs);

 if((cs=pApp->GetProfileString("Settings","StartTempTar",""))=="")
	{StartTempTar=0.0;
	 cs.Format("%f",StartTempTar);
	 pApp->WriteProfileString("Settings","StartTempTar",cs);
	}
 else StartTempTar=atof((LPCTSTR)cs);

	// 
	//NumTar=NUM_TAR;
	SPIRT_MVES=46.0;//    
	VODA_MVES=18.0;
	TAR_TE=1000.0;// 
	TAR_FMAX=100.0;// -   
	TIME_STEP=1.0;//  
	// 
	bEnbNextModel=false;
	//COEF_VOZVRATA=1.0;
	//OXL_FLEGMA=0.0;
	//NUM_ITERATION_SHOW=1000;
	//SpirtConcentrInBraga=0.1;
	//ExtCoolingPower=0.0;
	//StartTempTar=20.0;
	//bFlegmaCoeffFlegNumber=false; //-       SetParams

	// 
	ColInpPower=ColDeflegPower=0.0;
	CommonNumIterations=0;
	// 
	bTraceEBalance=false;//      TRACE - 
	// 
	// 
	//InpParState.m=1;
	//InpParState.n=0.1;
	//InpParState.t=GetRastvTKip(InpParState.n);//91.33;//   
	StartInitParams();
	return TRUE;
}

void CRCDoc::StartInitParams()
{int i;
if(pTS!=0) delete pTS;
pTS=new TarState[NumTar];
if(pISArr!=0) delete pISArr;
pISArr=new IntState[NumTar+1];

//  
for(i=0;i<NumTar;i++)	{pTS[i].m=0;pTS[i].n=0;pTS[i].t=StartTempTar;};
//   
pISArr[0].PS=InpParState;
pISArr[0].FS.m=0;pISArr[0].FS.n=0;pISArr[0].FS.t=StartTempTar;
	
for(i=1;i<NumTar+1;i++)
	{pISArr[i].PS.m=0;pISArr[i].PS.n=0;pISArr[i].PS.t=StartTempTar;
	 pISArr[i].FS.m=0;pISArr[i].FS.n=0;pISArr[i].FS.t=StartTempTar;
	};
}

/////////////////////////////////////////////////////////////////////////////
// CRCDoc serialization

void CRCDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CRCDoc diagnostics

#ifdef _DEBUG
void CRCDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CRCDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CRCDoc commands
void CRCDoc::SaveRegistryParams()
{CWinApp *pApp=AfxGetApp();
 CString cs;
 pApp->WriteProfileInt("Settings","NumTar",NumTar);
 pApp->WriteProfileInt("Settings","CoeffVozvrataType",bFlegmaCoeffFlegNumber);
 pApp->WriteProfileInt("Settings","bAutoParTemperature",bAutoParTemperature);
 cs.Format("%f",COEF_VOZVRATA);
 pApp->WriteProfileString("Settings","CoeffVozvrata",cs);
 cs.Format("%f",OXL_FLEGMA);
 pApp->WriteProfileString("Settings","FlegmaCooling",cs);
 pApp->WriteProfileInt("Settings","NumIterationShow",NUM_ITERATION_SHOW);
 
 cs.Format("%f",SpirtConcentrInBraga);
 pApp->WriteProfileString("Settings","SpirtConcentrInBraga",cs);

 cs.Format("%f",InpParState.m);
 pApp->WriteProfileString("Settings","InpParMass",cs);
 cs.Format("%f",InpParState.n);
 pApp->WriteProfileString("Settings","InpParConcentr",cs);
 cs.Format("%f",InpParState.t);
 pApp->WriteProfileString("Settings","InpParTemp",cs);

 cs.Format("%f",ExtCoolingPower);
 pApp->WriteProfileString("Settings","ExtCoolingPower",cs);
 
 cs.Format("%f",StartTempTar);
 pApp->WriteProfileString("Settings","StartTempTar",cs);
}


char * CRCDoc::GetColumnName(int ColNumber)
{return psColNames[ColNumber];}

double CRCDoc::GetSpirtTeploemc(double T)//()
{//double y;
 //if(T<0.0) T=0.0;
 //if(T>120.0) T=120.0;
 //y =2.26451+0.00666*T+4.95837E-5*T*T;
 //return y;//2.386476;////
 return 2.386476;
}

double CRCDoc::GetSpirtTepIsp(double T)//()
{//double y;
 //if(T<0.0) T=0.0;
 //if(T>120.0) T=120.0;
 //y =919.90624-0.1584*T-0.00796*pow(T,2)-1.042E-5*pow(T,3);
 //return y;//841.5468;///
 return 841.5468;///
}

double CRCDoc::GetVodaTeploemc(double T)//()
{return 4.1868;///
}

double CRCDoc::GetVodaTepIsp(double T)//()
{return 2256.26652;///
}

double CRCDoc::GetRastvTKip(double Nsp)//     
{double Tkip,x;
 x=Nsp*100.0;
 if((Nsp>0.0) && (Nsp<=0.9557))
 Tkip = 67.90835+6.47291*exp(-x/11.65031)
	 + 6.47336*exp(-x/11.89626) + 19.06894*exp(-x/156.08479);
 else
 {if((Nsp>=0.9557) && (Nsp<1.0))
	 {double Tkip0=Tkip=67.90835+6.47291*exp(-x/11.65031)
			+ 6.47336*exp(-x/11.89626) + 19.06894*exp(-x/156.08479);
	  Tkip=Tkip0+(78.4-Tkip0)*(Nsp-0.9557)/(1-0.9557);
	 };

  if(Nsp>=1.0) Tkip=78.4;
  if(Nsp<=0.0) Tkip=100.0;
 };
//y0	67.90835	\(177)11.26368
//A1	6.47291	\(177)423733.34503
//t1	11.65031	\(177)7848.27979
//A2	6.47336	\(177)423730.29884
//t2	11.89626	\(177)8261.09918
//A3	19.06894	\(177)8.04119
//t3	156.08479	\(177)168.60539
 return Tkip;
}

double CRCDoc::GetRastvParConc(double NspR)	//       
											//     
{double Nsp,x,y;
 if(NspR<0) x=0;
 else x=NspR*100.0;

 if(x>95.57) y=1.0;
 else
	{Nsp=1.0+0.05178/pow(x+5.24126,0.83811)*pow(95.57-x,1.5);
	//y0	1	\(177)0
	//A1	0.05178	\(177)0.0041
	//x0	5.24126	\(177)0.27452
	//n	0.83811	\(177)0.0231
	y=Nsp;
	};
 
 return y;
}
//  
void CRCDoc::CalcTar(int NumCurTar, IntState *pInt0,TarState *pTar,IntState *pInt1)
{double DE,EF0,EF1,Et0,Et1,EP0,EP1,EG;//   
 double f,f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f11,TTepl,PTepl,Tkip;
 BOOL bCondense=false;
 TarState pTS=*pTar;

 // ****   
 //    -    - 
 f=pInt1->FS.m*(pInt1->FS.n*GetSpirtTeploemc(pInt1->FS.t)+(1.0-pInt1->FS.n)*GetVodaTeploemc(pInt1->FS.t));
 //   
 EF0=f*pInt1->FS.t;
 //        - 
 f1=TAR_TE + pTS.m*(pTS.n*GetSpirtTeploemc(pTS.t)+(1.0-pTS.n)*GetVodaTeploemc(pTS.t));
 //  
 Et0=f1*pTS.t;
 //       
 pTS.t=(f*pInt1->FS.t+f1*pTS.t)/(f+f1);

 //   
 f=pTS.m*pTS.n+pInt1->FS.m*pInt1->FS.n;
 //   
 f1=pTS.m*(1.0-pTS.n)+pInt1->FS.m*(1.0-pInt1->FS.n);
 //    
 pTS.m=f+f1;
 //    
 if(pTS.m>0) pTS.n=f/pTS.m; else pTS.n=0; 
 
 //         - 
 TTepl=TAR_TE + pTS.m*(pTS.n*GetSpirtTeploemc(pTS.t)+(1.0-pTS.n)*GetVodaTeploemc(pTS.t));
 if((fabs(Et0+EF0-TTepl*pTS.t)>0.001) &&bTraceEBalance)
 {TRACE("Ebalance0::Et0+EF0=%.3f TTepl*pTS.t=%.3f\n",Et0+EF0,TTepl*pTS.t);
 };
 //  
 PTepl=pInt0->PS.m*(pInt0->PS.n*GetSpirtTeploemc(pInt0->PS.t)+(1.0-pInt0->PS.n)*GetVodaTeploemc(pInt0->PS.t));
 //  
 EP0=pInt0->PS.t*
	 (pInt0->PS.m*pInt0->PS.n*GetSpirtTeploemc(pInt0->PS.t)// 
	 +pInt0->PS.m*(1.0-pInt0->PS.n)*GetVodaTeploemc(pInt0->PS.t)// 
	 )
	 +pInt0->PS.m*pInt0->PS.n*GetSpirtTepIsp(pInt0->PS.t)//  
	 +pInt0->PS.m*(1.0-pInt0->PS.n)*GetVodaTepIsp(pInt0->PS.t)//  
	 ;

 // *****  ,  
 //    -    !!!
 f=(TTepl*pTS.t+PTepl*pInt0->PS.t)/(TTepl+PTepl);
 // ma
 f1=pTS.m+pInt0->PS.m;
 // 
 if(f1>0)
	f2=(pTS.n*pTS.m+pInt0->PS.n*pInt0->PS.m)/f1;
 else f2=0;
 //       
 f3=f+pInt0->PS.m
	 *(pInt0->PS.n*GetSpirtTepIsp(pInt0->PS.t)+(1-pInt0->PS.n)*GetVodaTepIsp(pInt0->PS.t))
	 /(TTepl+PTepl);
 // -  
 if(NumCurTar==NumTar-1)
	{f3 -= ExtCoolingPower/(TTepl+PTepl);
	};

 //  
 EG=f3*(TTepl+PTepl);
 //  
 Tkip=GetRastvTKip(f2);
 //if(NumCurTar==0)
 //{TRACE("***GTm=%.3f GTn=%.3f GTt=%.3f GTkip=%.3f::",f1,f2,f3,Tkip);
 //};
 //    -   
 if(f3<Tkip)
	 {//   -    -  
	  pTS.m=f1;
	  pTS.n=f2;
	  pTS.t=f3;
	  pInt1->PS.m=0;
	  pInt1->PS.n=pTS.n;
	  pInt1->PS.t=pTS.t;
	  //  
	  pInt0->FS.n=pTS.n;
	  pInt0->FS.t=pTS.t;
	  //if(NumCurTar==0)
	//	{TRACE("-T<Tkip-\n");
	//	};

	  if(pTS.m<=TAR_FMAX)
		{pInt0->FS.m=0;
		}
	  else  
		{pInt0->FS.m=pTS.m-TAR_FMAX;
	     pTS.m=TAR_FMAX;
		};
	 }
 else
	 {//   -  
	  pTS.m=f1;//      
	  pTS.n=f2;
	  pTS.t=f3;
	  // 
	  f4=(f3-Tkip)*(TTepl+PTepl);
	  //   
	  f5=pTS.n*GetRastvParConc(pTS.n);	//       
											//     
	  //  1  
	  f6=f5*GetSpirtTepIsp(Tkip)+(1.0-f5)*GetVodaTepIsp(Tkip);
CorrRepeat:;
	  // 
	  f7=f4/f6;
	  //    
	  f8=pTS.m*pTS.n-f7*f5;
	  if(f8<0)
		  {f7=(pTS.m*pTS.n-0.001)/f5;// 
		   f4=f7*f6;// 
		   goto CorrRepeat;
		  };
	  //    
	  f9=pTS.m*(1.0-pTS.n)-f7*(1.0-f5);
	  if(f9<0)
		  {f7=(pTS.m*(1.0-pTS.n)-0.001)/(1.0-f5);// 
		   f4=f7*f6;// 
		   goto CorrRepeat;
		  };
	  //  
	  pInt1->PS.m=f7;
	  pInt1->PS.n=f5;

	  //  
	  f10=f8+f9;
	  //   
	  if(f10>0) f11=f8/f10; else f11=0;
		
	  pTS.m=f10;//      
	  pTS.n=f11;

	  //  f4
	  // ma f1
	  //  TTepl+PTepl
	  //        f3
	  pTS.t=f3-f4/(TTepl+PTepl);//????
	  //pTS.t=f3-f4/TTepl;//????
	  pInt1->PS.t=pTS.t;//  
	  //if(NumCurTar==0)
		//{TRACE("-T>Tkip- Mp=%.3f\n",f7);
		//};
  	  //  
	   pInt0->FS.n=pTS.n;
	   pInt0->FS.t=pTS.t;
	  if(pTS.m<=TAR_FMAX)   pInt0->FS.m=0;
	  else  
		{pInt0->FS.m=pTS.m-TAR_FMAX;
	     pTS.m=TAR_FMAX;
		};
	  if(pTS.t>pInt0->PS.t)
	  {pTS.t=pTS.t;
	  };
	 };
  //  
  EP1=pInt1->PS.t*
	  (pInt1->PS.m*pInt1->PS.n*GetSpirtTeploemc(pInt1->PS.t)// 
	   +pInt1->PS.m*(1.0-pInt1->PS.n)*GetVodaTeploemc(pInt1->PS.t)// 
	  )
	 +pInt1->PS.m*pInt1->PS.n*GetSpirtTepIsp(pInt1->PS.t)//  
	 +pInt1->PS.m*(1.0-pInt1->PS.n)*GetVodaTepIsp(pInt1->PS.t);//  
  //     
  f=pInt0->FS.m*(pInt0->FS.n*GetSpirtTeploemc(pInt0->FS.t)+(1.0-pInt0->FS.n)*GetVodaTeploemc(pInt0->FS.t));
 //   
  EF1=f*pInt0->FS.t;
 //        - 
  f1=TAR_TE + pTS.m*(pTS.n*GetSpirtTeploemc(pTS.t)+(1.0-pTS.n)*GetVodaTeploemc(pTS.t));
 //  
  Et1=f1*pTS.t;
  // 
  DE=EF0//   
	 +Et0//  
	 +EP0//     
	 -EP1//     
	 -EF1//   
	 -Et1;//  
  if((fabs(DE)>0.001)&&bTraceEBalance)
  {TRACE("Ebalance1::DE=%.3f EF0=%.3f Et0=%.3f EP0=%.3f EP1=%.3f EF1=%.3f Et1=%.3f EG=%.3f\n",
		DE,EF0,Et0,EP0,EP1,EF1,Et1,EG);
  };

 *pTar=pTS;
}

//    
double CRCDoc::ConvMassConToVolCon(double MassConc)
{double f=MassConc*100.0; 
 return (-0.0284+1.26996*f-0.00179*pow(f,2)-9.0712E-6*pow(f,3))/100.0;
}
//    
double CRCDoc::ConvVolConToMassCon(double VolConc)
{double f=VolConc*100.0; 
 return (-0.13412+0.83749*f-0,00116*f*f+2.76728E-5*pow(f,3))/100.0;
}
