// RCDoc.h : interface of the CRCDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_RCDOC_H__DA9F5D12_06DC_494D_AAEF_0CB0760CC212__INCLUDED_)
#define AFX_RCDOC_H__DA9F5D12_06DC_494D_AAEF_0CB0760CC212__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define NUM_TAR 10

class CRCDoc : public CDocument
{
protected: // create from serialization only
	CRCDoc();
	DECLARE_DYNCREATE(CRCDoc)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRCDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	double ConvMassConToVolCon(double MassConc);
	double ConvVolConToMassCon(double VolConc);
	void SaveRegistryParams();
	//TarState TS[NUM_TAR];//  
	TarState *pTS;//  
	IntState *pISArr;
	//IntState ISArr[NUM_TAR+1];//   
	BOOL bEnbNextModel;
	void StartInitParams();
	double ColInpPower,ColDeflegPower;
	char *GetColumnName(int ColNumber);
	BOOL bTraceEBalance,bFlegmaCoeffFlegNumber,bAutoParTemperature;
	double ExtCoolingPower;
	double SpirtConcentrInBraga;
	void CalcTar(int NumTar, IntState *pInt0,TarState *pTar,IntState *pInt1);
	double GetRastvParConc(double Nsp);
	double GetRastvTKip(double Nsp);
	double GetSpirtTepIsp(double T);
	double GetSpirtTeploemc(double T);
	double GetVodaTepIsp(double T);
	double GetVodaTeploemc(double T);
	double TAR_TE,TAR_FMAX;//   -   
	double TIME_STEP;//  
	double COEF_VOZVRATA,OXL_FLEGMA;
	double StartTempTar;
	int NUM_ITERATION_SHOW,CommonNumIterations;
	int NumTar;
	ParState InpParState;
	double SPIRT_MVES,VODA_MVES;//    
	//double VODA_TEPL,VODA_TPISP;//     ()
	virtual ~CRCDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CRCDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RCDOC_H__DA9F5D12_06DC_494D_AAEF_0CB0760CC212__INCLUDED_)
